%global momorel 3
%global __libtoolize :

Summary: High-performance and highly configurable free RADIUS server.
Name: freeradius
Version: 1.1.1
Release: %{momorel}m
License: GPL
Group: System Environment/Daemons
URL: http://www.freeradius.org/
%NoSource 0 ftp://ftp.freeradius.org/pub/radius/%{name}-%{version}.tar.gz b38b24f6352090fdb571b9e8da52e12e
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Requires: net-snmp krb5-libs net-snmp-utils
PreReq: chkconfig, shadow-utils
BuildRequires: libtool pam-devel zlib-devel
BuildRequires: net-snmp-devel >= 5.3.1.0 net-snmp-utils krb5-devel openssl-devel
BuildRequires: mysql-devel unixODBC-devel gdbm-devel postgresql-devel
BuildRequires: openldap-devel >= 2.3.19
Patch2: freeradius-1.1.1-libdir.patch
Patch3: freeradius-0.9.0-pam-multilib.patch
Patch4: freeradius-0.9.0-com_err.patch
Patch5: freeradius-1.1.1-pie.patch
Patch8: freeradius-1.0.0-samba3.patch
Patch10: freeradius-1.1.1-libradius_install.patch
Patch11: freeradius-1.1.1-versionless-la-files.patch
Patch12: freeradius-1.1.1-docdir.patch


%description
The FreeRADIUS Server Project is a high performance and highly configurable
GPL'd free RADIUS server. The server is similar in some respects to
Livingston's 2.0 server.  While FreeRADIUS started as a variant of the
Cistron RADIUS server, they don't share a lot in common any more. It now has
many more features than Cistron or Livingston, and is much more configurable.

FreeRADIUS is an Internet authentication daemon, which implements the RADIUS
protocol, as defined in RFC 2865 (and others). It allows Network Access
Servers (NAS boxes) to perform authentication for dial-up users. There are
also RADIUS clients available for Web servers, firewalls, Unix logins, and
more.  Using RADIUS allows authentication and authorization for a network to
be centralized, and minimizes the amount of re-configuration which has to be
done when adding or deleting new users.

%package ldap
Summary: LDAP Authorizaion and Authenication Module for FreeRADIUS
Group: System Environment/Daemons
Requires: freeradius = %{version}
Requires: openldap, openssl, cyrus-sasl, gdbm
BuildPreReq: cyrus-sasl-devel
Requires: pam
BuildPreReq: openldap-devel, openssl-devel, gdbm-devel, pam-devel

%description ldap
This package contains the LDAP Authorization and Authentication module for FreeRADIUS.

%package mysql
Summary: MySQL bindings for freeradius
Group: System Environment/Daemons
Requires: %{name} = %{version}-%{release}
Requires: mysql

%description mysql
The FreeRADIUS Server Project is a high performance and highly configurable
GPL'd free RADIUS server. The server is similar in some respects to
Livingston's 2.0 server.  While FreeRADIUS started as a variant of the
Cistron RADIUS server, they don't share a lot in common any more. It now has
many more features than Cistron or Livingston, and is much more configurable.

FreeRADIUS is an Internet authentication daemon, which implements the RADIUS
protocol, as defined in RFC 2865 (and others). It allows Network Access
Servers (NAS boxes) to perform authentication for dial-up users. There are
also RADIUS clients available for Web servers, firewalls, Unix logins, and
more.  Using RADIUS allows authentication and authorization for a network to
be centralized, and minimizes the amount of re-configuration which has to be
done when adding or deleting new users.

%package postgresql
Summary: postgresql bindings for freeradius
Group: System Environment/Daemons
Requires: %{name} = %{version}-%{release}
Requires: postgresql
Provides: freeradius-pgsql
Obsoletes: freeradius-pgsql

%description postgresql
The FreeRADIUS Server Project is a high performance and highly configurable
GPL'd free RADIUS server. The server is similar in some respects to
Livingston's 2.0 server.  While FreeRADIUS started as a variant of the
Cistron RADIUS server, they don't share a lot in common any more. It now has
many more features than Cistron or Livingston, and is much more configurable.

FreeRADIUS is an Internet authentication daemon, which implements the RADIUS
protocol, as defined in RFC 2865 (and others). It allows Network Access
Servers (NAS boxes) to perform authentication for dial-up users. There are
also RADIUS clients available for Web servers, firewalls, Unix logins, and
more.  Using RADIUS allows authentication and authorization for a network to
be centralized, and minimizes the amount of re-configuration which has to be
done when adding or deleting new users.

%package unixODBC
Summary: unixODBC bindings for freeradius
Group: System Environment/Daemons
Requires: %{name} = %{version}-%{release}
Requires: unixODBC
Provides: freeradius-unixodbc
Obsoletes: freeradius-unixodbc

%description unixODBC
The FreeRADIUS Server Project is a high performance and highly configurable
GPL'd free RADIUS server. The server is similar in some respects to
Livingston's 2.0 server.  While FreeRADIUS started as a variant of the
Cistron RADIUS server, they don't share a lot in common any more. It now has
many more features than Cistron or Livingston, and is much more configurable.

FreeRADIUS is an Internet authentication daemon, which implements the RADIUS
protocol, as defined in RFC 2865 (and others). It allows Network Access
Servers (NAS boxes) to perform authentication for dial-up users. There are
also RADIUS clients available for Web servers, firewalls, Unix logins, and
more.  Using RADIUS allows authentication and authorization for a network to
be centralized, and minimizes the amount of re-configuration which has to be
done when adding or deleting new users.


%prep
%setup -q
%patch2 -p1 -b .libdir
%patch3 -p1 -b .pam-multilib
%patch4 -p1 -b .com_err
%patch5 -p1 -b .pie
%patch8 -p1 -b .samba3
%patch10 -p1 -b .libradius_install
%patch11 -p1 -b .versionless
%patch12 -p1 -b .docdir


%build
%ifarch s390 s390x
export CFLAGS="$RPM_OPT_FLAGS -fPIC"
%else
export CFLAGS="$RPM_OPT_FLAGS -fpic"
%endif
%configure \
  --with-gnu-ld \
  --with-threads \
  --with-thread-pool \
  --with-system-libtool \
  --disable-ltdl-install \
  --with-snmp \
  --with-static-modules="" \
  --with-experimental-modules \
  --with-large-files
%make

# remove '--disable-static' 2006-04-22
# version 1.1.1 specifically BUG
# see, http://bugs.freeradius.org/show_bug.cgi?id=350


%install
rm -fr --preserve-root %{buildroot}
mkdir -p %{buildroot}%{_sysconfdir}/{logrotate.d,pam.d,rc.d/init.d}
%makeinstall

RADDB=%{buildroot}%{_sysconfdir}/raddb
# set radiusd as default user/group
perl -i -pe 's/^#user =.*$/user = radiusd/' $RADDB/radiusd.conf
perl -i -pe 's/^#group =.*$/group = radiusd/' $RADDB/radiusd.conf
# shadow password file MUST be defined on Linux
perl -i -pe 's/#  shadow =/shadow =/' $RADDB/radiusd.conf

install -m 755 redhat/rc.radiusd-redhat %{buildroot}%{_sysconfdir}/rc.d/init.d/radiusd
install -m 644 redhat/radiusd-logrotate %{buildroot}%{_sysconfdir}/logrotate.d/radiusd
install -m 644 redhat/radiusd-pam %{buildroot}%{_sysconfdir}/pam.d/radiusd

# remove unwanted rc.radiusd
rm -f %{buildroot}%{_sbindir}/rc.radiusd

find %{buildroot}%{_libdir} -name "*.la" -print | xargs rm -f
find %{buildroot}%{_libdir} -name "*.a" -print | xargs rm -f

mkdir -p %{buildroot}/var/log/radius
touch    %{buildroot}/var/log/radius/{radutmp,radwtmp,radius.log}
mkdir -p %{buildroot}/var/log/radius/radacct
mkdir -p %{buildroot}/var/run/radiusd


%clean
rm -fr --preserve-root %{buildroot}


%pre
/usr/sbin/useradd -M -o -r -d / -u 95 -c "radiusd user" -s /bin/false radiusd > /dev/null 2>&1 || :


%post
/sbin/ldconfig
if [ $1 = 1 ]; then
  /sbin/chkconfig --add radiusd
fi
for i in /var/log/radius/{radutmp,radwtmp,radius.log}; do
  /bin/touch $i && /bin/chown radiusd: $i && /bin/chmod 600 $i
done


%preun
if [ $1 = 0 ]; then
  /sbin/service radiusd stop > /dev/null 2>&1
  /sbin/chkconfig --del radiusd
fi

%postun
if [ $1 -ge 1 ]; then
  /sbin/service radiusd condrestart >/dev/null 2>&1 || :
fi
/sbin/ldconfig


%files
%defattr(-,root,root,-)
%doc %{_docdir}/freeradius-%{version}/
%config (noreplace) /etc/pam.d/radiusd
%config (noreplace) /etc/logrotate.d/radiusd
%config (noreplace) /etc/rc.d/init.d/radiusd
%config (noreplace) /etc/raddb/[a-ce-z]*
%config /etc/raddb/dictionary*
%{_bindir}/*
%{_libdir}/libeap*.so
%{_libdir}/libradius*.so
%{_libdir}/rlm_[a-k]*.so
%{_libdir}/rlm_[m-r]*.so
%{_libdir}/rlm_sim_files*.so
%{_libdir}/rlm_smb*.so
%{_libdir}/rlm_sql-%{version}*.so
%{_libdir}/rlm_sql.so
%{_libdir}/rlm_sql_log-%{version}.so
%{_libdir}/rlm_sql_log.so
%{_libdir}/rlm_sqlcounter-%{version}.so
%{_libdir}/rlm_sqlcounter.so
%{_libdir}/rlm_[t-z]*.so
%{_datadir}/freeradius
%{_sbindir}/*
%{_mandir}/man1/*.1*
%{_mandir}/man5/*.5*
%{_mandir}/man8/*.8*
%attr(0700,radiusd,radiusd) %dir /var/log/radius
%ghost %attr(0600,radiusd,radiusd) /var/log/radius/radutmp
%ghost %attr(0600,radiusd,radiusd) /var/log/radius/radwtmp
%ghost %attr(0600,radiusd,radiusd) /var/log/radius/radius.log
%attr(0700,radiusd,radiusd) %dir /var/log/radius/radacct
%attr(0700,radiusd,radiusd) %dir /var/run/radiusd

%files ldap
%defattr(-,root,root,-)
%{_libdir}/*_ldap*.so

%files mysql
%defattr(-,root,root,-)
%{_libdir}/*_mysql*.so

%files postgresql
%defattr(-,root,root,-)
%{_libdir}/*_postgresql*.so

%files unixODBC
%defattr(-,root,root,-)
%{_libdir}/*_unixodbc*.so


%changelog
* Wed Aug  9 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (1.1.1-3m)
- rebuild against net-snmp 5.3.1.0

* Tue May 17 2006 Yasuo Ohgaki <yohgaki@momonga-linux.org>
- (1.1.1-1m)
- rebuild against mysql 5.0.22-1m

* Sun Apr 23 2006 Ryu SASAOKA <ryu@momonga-linux.org>
- (1.1.1-1m)
- [SECURITY] CVE-2006-1354 CVE-2005-1454 CVE-2005-1455
- http://www.freeradius.org/security.html
- add Patch10: freeradius-1.1.1-libradius_install.patch (from Gentoo)
-     Patch11: freeradius-1.1.1-versionless-la-files.patch (from Gentoo)
-     Patch12: freeradius-1.1.1-docdir.patch
- update Patch2: freeradius-1.1.1-libdir.patch
-        Patch5: freeradius-1.1.1-pie.patch
- remove Patch1: freeradius-1.0.0-ltdl_no_la.patch
-        Patch6: freeradius-0.9.3-gcc34.patch
-        Patch7: freeradius-1.0.2-sasl2.patch
- remove --disable-static option for specific BUG at version 1.1.1 
- add REMOVE.PLEASE

* Sun Apr  9 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (1.0.2-6m)
- rebuild against openldap-2.3.19

* Sat Jan 14 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (1.0.2-5m)
- rebuild against openldap-2.3.11

* Sat Nov 19 2005 Shigeyuki Yamashita <shige@momonga-linux.org>
- (1.0.2-4m)
- rebuild against postgresql-8.1.0

* Mon Sep  5 2005 YONEKAWA Susumu <yonekawa@mmg.roka.jp>
- (1.0.2-3m)
- rebuild against for MySQL-4.1.14

* Mon Apr 25 2005 Toru Hoshina <t@momonga-linux.org>
- (1.0.2-2m)
- rebuild against postgresql-8.0.2.

* Thu Mar 10 2005 Kazuhiko <kazuhiko@fdiary.net>
- (1.0.2-1m)
- version up since 1.0.1 tarball moved to old/
- Provides and Obsoletes freeradius-pgsql
- Provides and Obsoletes freeradius-unixodbc

* Thu Mar 10 2005 Toru Hoshina <t@momonga-linux.org>
- (1.0.1-1m)
- sync with FC3. specopt is fully disabled.

* Tue Feb 15 2005 Dai OKUYAMA <dai@ouchi.nahi.to>
- (0.9.3-7m)
- enable x86_64.

* Wed Oct 27 2004 Hiroyuki Koga <kuma@momonga-linux.org>
- (0.9.3-6m)
- add gcc34 patch

* Mon Aug 23 2004 Tsutomu Yasuda <tom@tom.homelinux.org>
- (0.9.3-5m)
  revised source url

* Sun Jul  4 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (0.9.3-4m)
- stop daemon

* Thu Apr  8 2004 Hiroyuki Koga <kuma@momonga-inux.org>
- (0.9.3-3m)
- correct comment out for _initscriptdir macro
- use %%NoSource and %%make
- add Prereq: chkconfig, initscripts

* Fri Mar 19 2004 Toru Hoshina <t@momonga-linux.org>
- (0.9.3-2m)
- revised spec for enabling rpm 4.2.
- add postgresql and unixodbc support packages.

* Mon Jan 26 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (0.9.3-1m)
- update to 0.9.3

* Tue Nov 18 2003 YAMAZAKI Makoto <zaki@zakky.org>
- (0.9.1-3m)
- add BuildConflicts: db2-devel
- add patch to be compiled with gdbm-1.8.3(libgdbm_compat)
- fix install directory of README.rpm

* Mon Nov 10 2003 Kazuhiko <kazuhiko@fdiary.net>
- (0.9.1-2m)
- rebuild against gdbm-1.8.0-19m

* Mon Oct 14 2003 Shingo Akagaki <dora@kitty.dnsalias.org>
- (0.9.1-1m)
- version 0.9.1

* Wed Sep  3 2003 YONEKAWA Susumu <yonekawa@mmg.roka.jp>
- (0.8.1-6m)
- rebuild against for MySQL-4.0.14-1m
- License: GPL
- BuildRoot: %{_tmppath}/%{name}-%{version}-root

* Thu Jun 19 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (0.8.1-5m)
  rebuild against cyrus-sasl2

* Thu Mar  6 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (0.8.1-4m)
  rebuild against openssl 0.9.7a

* Mon Feb 10 2003 Shingo Akagaki <dora@kitty.dnsalias.org>
- (0.8.1-3m)
- rebuild against for gdbm

* Sun Feb  9 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (0.8.1-2m)
- %%install: rm -rf %{buildroot} before install

* Fri Feb  7 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (0.8.1-1m)
  update to 0.8.1

* Sun Jan 05 2003 Tadataka Yoshikawa <yosshy@momonga-linux.org>
- (0.7.1-2m)
- fix Source URI.

* Fri Nov 01 2002 YAMAGUCHI Kenji <yamk@momonga-linux.org>
- This RPM were created by Shawn K. O'Shea <pkg@eth0.net>
- get from http://volcano.boulderhill.net/freeradius-rpm/
- see http://volcano.boulderhill.net/freeradius-rpm/README.rpm.txt
- Momongized.
- NoSource.
- update to 0.7.1
- enable support mysql and ldap as default
